#ifndef KYSEC_ERROR_H__
#define KYSEC_ERROR_H__

#define KYSEC_ERR_OBJ_LEN   256
#define KYSEC_ERR_MSG_LEN   1024

typedef struct kysec_error
{
    int err_no;
    char err_obj[KYSEC_ERR_OBJ_LEN];
    char err_msg[KYSEC_ERR_MSG_LEN];
}kysec_error;

#define KYLIN_KYSEC_OK                      0               //无错误
#define KYLIN_KYSEC_ERR_BASE                -1000             //错误基准值
#define KYLIN_KYSEC_AUTH_FAILED             KYLIN_KYSEC_ERR_BASE - 1               //认证失败
#define KYLIN_KYSEC_CANCEL_AUTH             KYLIN_KYSEC_ERR_BASE - 2               //取消认证
#define KYLIN_KYSEC_DISABLED                KYLIN_KYSEC_ERR_BASE - 3               //KYSEC未启动
#define KYLIN_KYSEC_DATABASE_ERR            KYLIN_KYSEC_ERR_BASE - 4               //数据库错误
#define KYLIN_KYSEC_LABEL_GET_ERR           KYLIN_KYSEC_ERR_BASE - 5               //获取KYSEC标记失败
#define KYLIN_KYSEC_LABEL_SET_ERR           KYLIN_KYSEC_ERR_BASE - 6               //设置KYSEC标记失败
#define KYLIN_KYSEC_INVALID_ARG             KYLIN_KYSEC_ERR_BASE - 7               //参数错误
#define KYLIN_KYSEC_EXTRACT_LIST_ERR        KYLIN_KYSEC_ERR_BASE - 8               //获取列表失败
#define KYLIN_KYSEC_FILE_ATTR_ERR           KYLIN_KYSEC_ERR_BASE - 9               //文件属性异常
#define KYLIN_KYSEC_CONF_ERR	            KYLIN_KYSEC_ERR_BASE - 10               //读写安全状态配置文件失败
#define KYLIN_KYSEC_OTHER_ERR               KYLIN_KYSEC_ERR_BASE - 11               //其他错误
#define KYLIN_KYSEC_NETCTL_ERR              KYLIN_KYSEC_ERR_BASE - 12               //读写网络管控配置文件失败
#define KYLIN_KYSEC_DEVCTL_ERR              KYLIN_KYSEC_ERR_BASE - 13               //设备管控操作失败
#define KYLIN_KYSEC_DEVCTL_ADD_EXIST        KYLIN_KYSEC_ERR_BASE - 14               //设备权限添加已存在
#define KYLIN_KYSEC_DEVCTL_UPDATE_REPEATE   KYLIN_KYSEC_ERR_BASE - 15                //设备管控策略更新重复

#ifdef __cplusplus
extern "C" {
#endif

extern void kysec_set_error(int err_no, char *err_obj, char *format, ...);
extern kysec_error *kysec_get_error();

#ifdef __cplusplus
}
#endif

#endif // ! KYSEC_ERROR_H__
